--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:58:11 05/14/2015
-- Design Name:   
-- Module Name:   E:/Dennis/Dropbox/nog plaatsen/MijnVisionProject/tb_image_tresholding.vhd
-- Project Name:  vision
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: image_tresholding
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_image_tresholding IS
END tb_image_tresholding;
 
ARCHITECTURE behavior OF tb_image_tresholding IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT image_tresholding
    PORT(
         VSYNC_IN : IN  std_logic;
         HREF_IN : IN  std_logic;
         CAMERA_DATABUS_IN : IN  std_logic_vector(7 downto 0);
         CLOCK_IN : IN  std_logic;
         HREF_OUT : OUT  std_logic;
         VSYNC_OUT : OUT  std_logic;
         CAMERA_DATABUS_OUT : OUT  std_logic_vector(15 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal VSYNC_IN : std_logic := '1';
   signal HREF_IN : std_logic := '0';
   signal CAMERA_DATABUS_IN : std_logic_vector(7 downto 0) := (others => '0');
   signal CLOCK_IN : std_logic := '0';

 	--Outputs
   signal HREF_OUT : std_logic;
   signal VSYNC_OUT : std_logic;
   signal CAMERA_DATABUS_OUT : std_logic_vector(15 downto 0);

   -- Clock period definitions
   constant CLOCK_IN_period : time := 40 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: image_tresholding PORT MAP (
          VSYNC_IN => VSYNC_IN,
          HREF_IN => HREF_IN,
          CAMERA_DATABUS_IN => CAMERA_DATABUS_IN,
          CLOCK_IN => CLOCK_IN,
          HREF_OUT => HREF_OUT,
          VSYNC_OUT => VSYNC_OUT,
          CAMERA_DATABUS_OUT => CAMERA_DATABUS_OUT
        );

   -- Clock process definitions
   CLOCK_IN_process :process
   begin
		CLOCK_IN <= '0';
		wait for CLOCK_IN_period/2;
		CLOCK_IN <= '1';
		wait for CLOCK_IN_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 120 ns;	
		VSYNC_IN <= '0';
		wait for 500 ns;
		HREF_IN <= '1';
		wait for 500 ns;
		
		CAMERA_DATABUS_IN <= X"EE"; --lsb pixel1 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"EE"; --msb pixel1 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"11"; --lsb pixel2 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"11"; --msb pixel2 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"EE"; --lsb pixel3 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"EE"; --msb pixel3 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"11"; --lsb pixel4 in 1 clk cycle
		wait for 40nS; 
		CAMERA_DATABUS_IN <= X"11"; --msb pixel4 in 1 clk cycle
		wait for 40nS; 
		
		HREF_IN <= '0'; --back to idle, first frame transferred
		wait for 500 ns;
		VSYNC_IN <= '1';
		wait for 500 ns;
		
      wait;
   end process;

END;
